/*
Dozen Days of Words episode 6: Word Slide
Copyright (c) 2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.dozendays.words.slide
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	public class SlideList
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const WORDS_IN_LIST:int = 25;
		public static const MIN_WORD_LENGTH:int = 4;
		public static const MAX_WORD_LENGTH:int = 7;

		private const WORD_HEIGHT:int = 16;
		private const WORD_WIDTH:int = 150;
		private const WORD_FONT_SIZE:int = 14;
		private const WORD_COLOR:uint = 0xFFFFC0;
		private const WORD_BACKGROUND_COLOR:uint = 0x404010;
		private const WORD_LIST:Array = new Array(
			"ACRE", "AERY", "AMOK", "ANKH",
			"BELL", "BITE", "BRAT", "BUZZ",
			"CAKE", "CAMP", "CAVE", "CHEW", "CLAP", "CODE", "CYAN",
			"DAMP","DIET","DIRE","DOOM","DOWN",
			"EDIT","ETCH","EVEN","EVIL",
			"FALL","FAME","FAST","FATE","FIRE",
			"GOLD","GLUT",
			"HALL","HEAT","HELP","HINT","HOST",
			"INCH","IRON","JADE","KICK","KING",
			"LACE","LADY","LAMB","LION","LYNX",
			"MALT","MARE","MIND","MYST","NAVY","NEST",
			"OMEN","PALM","PARK","PLAY","PLUS","PONY",
			"QUIT","QUIZ","RAGE","RAZE","REST","RIFT","RING",
			"SHOW","SIZE","SOCK","STAR",
			"TIRE","TUNA",
			"VEIL","VEST","VIEW",
			"WANE","WARP","WHIP","WISH",
			"ABBEY", "ACORN", "ALIAS", "ALPHA", "ANVIL",
			"BERRY", "BLACK", "BROWN", "BUNCH",
			"CANON", "CARVE", "CHAIN", "CHAOS",
			"DECAL","DEVIL","DRAFT","DRESS","DRUNK",
			"ELBOW","EMPTY","ENEMY","ENTER","EXTRA",
			"FABLE","FEIGN","FLAME","FLOAT","FLUID",
			"GIANT","GLAZE","GOOSE","GRAIL","GRAZE",
			"HANDY","HERTZ","HONEY","HORSE","HUMAN",
			"IGLOO","INDEX","ISSUE","IVORY",
			"JUDGE","KNIFE",
			"LEMON","LEVER","LIGHT","LLAMA","LUNGE",
			"MAJOR","MEDIA","MERIT","MONEY",
			"NEXUS","NOISE","NYMPH",
			"OPERA","ORDER",
			"PEACE","PHOTO","PIANO","PLANT","PRISM",
			"QUAKE","RAPID","RHINO","ROYAL",
			"SABRE","SENSE","SEIGE","SLEEP","SOLID","SOUND","SPOON",
			"STORY","STUFF",
			"TABLE","THEME","THINK","TOKEN","TOTEM",
			"ULTRA","UNION","USHER",
			"VERGE","VIXEN",
			"WATER","WHEAT","WRITE",
			"ABACUS","ACTION", "ADVENT", "ALMOND",
			"BLEARY", "BLAZER", "BRIGHT", "BUSHEL",
			"CENTER", "CHERRY", "CHROME",
			"DEDUCT","DEGREE","DIVINE","DYNAMO","DOUBLE",
			"ELEVEN","EMBLEM","ENCORE","ENGINE",
			"FABRIC","FIGURE","FINGER","FLAVOR","FREEZE",
			"GARDEN","GENTRY","GREASE","GROOVE",
			"HEALTH","HOLLOW","HUBCAP",
			"IMPEND","INBORN","INDIGO","INSIDE",
			"JIGSAW","JUNGLE","KARATE",
			"LEAGUE","LITTLE","LUXURY",
			"MASTER","MATRIX","MENTAL","MILLET","MINUTE","MUTANT",
			"NATURE","NOVICE",
			"OCCULT","ORNATE","OXYGEN",
			"PARROT","PERSON","POLICE","POTION",
			"QUARRY","QUIVER",
			"RABBIT","RELISH","REPAIR",
			"SATIRE","SECOND","STRIKE","SYMBOL",
			"TENANT","THROAT","TRAVEL","TURTLE",
			"VIRTUE","VORTEX",
			"WEEKLY","WILLOW","WONDER","WRAITH",
			"ABANDON", "ACRYLIC", "ALLERGY", "ANTIGEN",
			"BLUBBER", "BONANZA", "BULLDOG", "BURETTE",
			"CAPITAL", "CARCASS", "CARTOON", "CIRCUIT", "COMPLEX", "CYCLONE",
			"DENTIST","DESTROY","DISRUPT","DURABLE",
			"ELASTIC","EPISODE","EXHAUST","EXPLODE",
			"FEARFUL","FLATTEN","FOOLISH","FORSAKE","FRIZZLE",
			"GRAMMAR","GRUMBLE",
			"HAYWIRE","HYDRANT","HYDRATE",
			"IMAGINE","IMITATE","IMPRESS","INFLICT","INSPECT",
			"JOURNEY","JUKEBOX",
			"KETCHUP","KNOWING",
			"LATTICE","LOTTERY",
			"MACHINE","MAGENTA","MEASURE","MISSION",
			"NOSTRIL","NURTURE",
			"OBSCURE","OUTPOST",
			"PATRIOT","PERFECT","PITCHER","PRELUDE","PROTEIN",
			"QUINTET",
			"REAGENT","REFLECT","RELEASE","REVENGE","ROMANCE",
			"SNEAKER","SPECIAL","SPINDLE","SUBJECT","SUSPECT",
			"TERRIFY","TRAFFIC","TRIBUTE","TRUFFLE",
			"UNCLEAN","UNEARTH",
			"VACCINE","VANTAGE",
			"WHITTLE","WORKING"
		);

// ***** VARIABLES **********************************************************

		public var _currentList:Array;
		public var _currentLetterList:Array;

		protected var _words:Array;

// ***** CONSTRUCTOR ********************************************************

		public function SlideList()
		{
			_currentList = new Array();
			_currentLetterList = new Array();
			_words = new Array();
			var wordFormat:TextFormat = new TextFormat(null, WORD_FONT_SIZE, WORD_COLOR, null, null, null, null, null, TextFormatAlign.CENTER);
			for (var cntr:int = 0; cntr < WORDS_IN_LIST; ++cntr) {
				_words[cntr] = new TextField();
				_words[cntr].y = WORD_HEIGHT * cntr;
				_words[cntr].width = WORD_WIDTH;
				_words[cntr].height = WORD_HEIGHT;
				_words[cntr].background = true;
				_words[cntr].backgroundColor = WORD_BACKGROUND_COLOR;
				addChild(_words[cntr]);
			}
		}

// ***** Functions - Puzzle Handling ****************************************

		public function addWord(s:String):void
		{
			_currentList.push(s);
			
			// break appart letters
			for (var cntrLetter:int = 0; cntrLetter < s.length; ++cntrLetter)
				_currentLetterList.push(s.charAt(cntrLetter));
		}
		
		protected function updateDisplay():void
		{
			var cntr:int;
			
			for (cntr = 0; cntr < _currentList.length; ++cntr)
				_words[cntr].text = _currentList[cntr];
			for (cntr = _currentList.length; cntr < WORDS_IN_LIST; ++cntr)
				_words[cntr].text = " ";
		}

		public function startLevel():void
		{
//			var levelIndex:int = Math.min(Math.max(n-1, 0), WORD_LIST.length-1);
//			var words:Array = WORD_LISTS[levelIndex];

			// clear the old data (if any)
			while (_currentList.length > 0) _currentList.pop();
			
			// create the initial list of words
			for (var cntr:int = 0; cntr < WORDS_IN_LIST; ++cntr) {
				addWord(WORD_LIST[Math.floor(Math.random()*WORD_LIST.length)]);
			}

			updateDisplay();
		}
		
		public function getNextLetter():String
		{
			if (_currentLetterList.length < 1)
				return "*";
			var indx:int = Math.floor(Math.random() * _currentLetterList.length);
			var s:String = _currentLetterList[indx];
			_currentLetterList[indx] = _currentLetterList[_currentLetterList.length-1];
			_currentLetterList.pop();
			return s;
		}
		
		public function wasWordInList(s:String):Boolean
		{
			var indx:int = -1;
			
			for (var cntr:int = 0; cntr < _currentList.length; ++cntr)
				if (_currentList[cntr] == s)
					indx = cntr;
			
			if (indx < 0)
				return false;
			
			_currentList[indx] = _currentList[_currentList.length - 1];
			_currentList.pop();
			addWord(WORD_LIST[Math.floor(Math.random()*WORD_LIST.length)]);
			updateDisplay();
			return true;
		}
		
	}
}
